// ================================================ =============================
//Z_Wolfzq_Sprite.js
// ================================================ =============================

/*:
 * @plugindesc wolfzq追加图像
 * @author wolfzq
 */

//-----------------------------------------------------------------------------
//追加场景数字图像
//-----------------------------------------------------------------------------
// Sprite_Number
//

function Sprite_Number() {
    this.initialize.apply(this, arguments);
}

Sprite_Number.prototype = Object.create(Sprite.prototype);
Sprite_Number.prototype.constructor = Sprite_Number;

Sprite_Number.prototype.initialize = function(x, y, color, value) {
    Sprite.prototype.initialize.call(this);
    this._numberBitmap = ImageManager.loadSystem('Damage');
	this._x = x;
	this._y = y;
	this.createNumber(color, value);
};

Sprite_Number.prototype.update = function() {
    Sprite.prototype.update.call(this);
    this.updatePosition();
};
Sprite_Number.prototype.updatePosition = function() {
    this.x = this.screenX();
    this.y = this.screenY();
    this.z = this.screenZ();
};
Sprite_Number.prototype.screenX = function() {
    var tw = $gameMap.tileWidth();
    return Math.round($gameMap.adjustX(this._x) * tw + tw / 2);
};

Sprite_Number.prototype.screenY = function() {
    var th = $gameMap.tileHeight();
    return Math.round($gameMap.adjustY(this._y) * th + th / 2);
};
Sprite_Number.prototype.screenZ = function() {
    return 0;
};

Sprite_Number.prototype.createNumber = function(color, value) {
    var string = Math.abs(value).toString();
    var w = this.digitWidth();
    var h = this.digitHeight();
    for (var i = 0; i < string.length; i++) {
        var sprite = this.createChildSprite();
        var n = Number(string[i]);
        sprite.setFrame(n * w, color * h, w, h);
        sprite.x = (i - (string.length - 1) / 2) * w;
        sprite.dy = -i;
    }
};

Sprite_Number.prototype.digitWidth = function() {
    return this._numberBitmap ? this._numberBitmap.width / 10 : 0;
};

Sprite_Number.prototype.digitHeight = function() {
    return this._numberBitmap ? this._numberBitmap.height / 5 : 0;
};

Sprite_Number.prototype.createChildSprite = function() {
    var sprite = new Sprite();
    sprite.bitmap = this._numberBitmap;
    sprite.anchor.x = 0.5;
    sprite.anchor.y = 1;
    sprite.y = -40;
    sprite.ry = sprite.y;
    this.addChild(sprite);
    return sprite;
};